from django.shortcuts import render, redirect
from django.http import HttpResponse, HttpResponseRedirect
from .models import ContactDetail, Enquiry
from .form import UserEnquiryForm, forms, Subscribe
from django.core.mail import send_mail
from MandiGram.settings import EMAIL_HOST_USER
from django.core.mail import send_mail, EmailMessage
from . import form
from django.template.loader import render_to_string

'''
def Contact_Enquiry(request):

    try:
        list_contact = UserEnquiryForm.objects.all()

    except:
        return HttpResponse("error while reading database")

    return render(request, 'enquiry_html/contactpage.html', {"contact": list_contact})
'''

def Contact_Enquiry(request):

    user_enquiry = UserEnquiryForm()

    if request.method == "POST":

        enquiry = UserEnquiryForm(request.POST, request.FILES)

        if enquiry.is_valid():

            user_enq = enquiry.save(commit=False)

            try:
                user_enq.file = request.FILES['file']

            except:
                clientmail(request, enquiry)
                adminmail(request, enquiry)
                recepient = str(enquiry['email'].value())
                return render(request, 'enquiry_html/ThankYou.html', {'recepient': recepient})

            finally:
                user_enq.save()

        else:
            print(user_enquiry.errors)

        clientmail(request, enquiry)
        adminmail(request, enquiry)
        recepient = str(enquiry['email'].value())
        return render(request, 'enquiry_html/ThankYou.html', {'recepient': recepient})

    else:
        user_enquiry = UserEnquiryForm()

    try:
        list_contact = ContactDetail.objects.all()

    except:
        return HttpResponse("error while reading database")

    return render(request, 'enquiry_html/contactpage.html', {"contact": list_contact,
                                                             'user_form': user_enquiry})


def Thanks(request):

    return render(request, 'enquiry_html/ThankYou.html', {})


def subscribe(request):
    sub = form.Subscribe()
    if request.method == 'POST':
        sub = form.Subscribe(request.POST)
        subject = 'Welcome to mangal technology '
        message = 'Thank you  for connecting with mangal technology and IT solutions'
        recepient = str(sub['Email'].value())
        send_mail(subject,message, EMAIL_HOST_USER, [recepient], fail_silently = False)
        return render(request, 'enquiry_html/success.html', {'recepient': recepient})
    return render(request, 'enquiry_html/contactpage.html', {'form': sub})


def clientmail(request,enquiry):
    subject = 'Welcome to mangal technology '
    name = str(enquiry['company_enquire_name'].value())
    recepient = str(enquiry['email'].value())
    recepient_name = str(enquiry['company_enquire_name'].value())
    contact = str(enquiry['phone'].value())
    service = str(enquiry['service_product'].value())
    description = str(enquiry['requirements'].value())
    html_template = 'enquiry_html/cusmoter_mail.html'
    html_message = render_to_string(html_template, {'service': service,
                                                    'name': recepient_name,
                                                    'contact': contact,
                                                    'description': description,
                                                    })
    mail = EmailMessage(subject, html_message, EMAIL_HOST_USER, [recepient])
    mail.content_subtype = 'html'
    mail.send()


def adminmail(request, enquiry):

    subject = "New " + str(enquiry['service_product'].value()) + " submitted"
    recepient = "vijaychourey26@gmail.com"
    service = str(enquiry['service_product'].value())
    name = str(enquiry['company_enquire_name'].value())
    conatct = str(enquiry['phone'].value())
    mail = str(enquiry['email'].value())
    description = str(enquiry['requirements'].value())

    # import file with html content
    html_template = 'enquiry_html/admin_mail.html'
    html_message = render_to_string(html_template, {'service': service,
                                                    'name': name,
                                                    'conatct': conatct,
                                                    'mail': mail,
                                                    'description': description,
                                                    })

    mail = EmailMessage(subject, html_message, EMAIL_HOST_USER, [recepient])
    if enquiry['file'].value():
        attachment = enquiry['file'].value()
        mail.attach(attachment.name, attachment.read(), attachment.content_type)
    mail.content_subtype = 'html'
    mail.send()

